=== Examples/ImageDatabaseServer/CMakeLists.txt ===
PROJECT(ImageDatabaseServer)

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

find_package(OpenIGTLink REQUIRED)

include(${OpenIGTLink_USE_FILE})


## igtl::ImageDatabaseMessage examples
ADD_EXECUTABLE(ImageDatabaseServer   ImageDatabaseServer.cxx)
TARGET_LINK_LIBRARIES(ImageDatabaseServer OpenIGTLink)
