=== debian/changelog ===
openigtlink (3.0.0-3) unstable; urgency=medium

  * debian/rules: remove hard-coded -DCMAKE_BUILD_TYPE
  * debian/control: declare Rules-Requires-Root: no

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 06 Sep 2025 02:03:45 -0400

openigtlink (3.0.0-2) unstable; urgency=medium

  * Fix FTBFS with CMake 4 (Closes: #1113357)
  * openigtlink 3.0 fixes socket close issue (Closes: #1010511)

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 05 Sep 2025 15:56:03 -0400

openigtlink (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * SONAME bump from 1.11 to 3.0
  * update debian/patches

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 16 May 2025 11:57:45 -0400

openigtlink (1.11.0-6) unstable; urgency=medium

  * debhelper-compat 13
  * Update Standards version to 4.7.2
  * Move from CDBS to debhelper (Closes: #1099947)
  * fix invalid short license name
  * update copyright-format fields

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 05 May 2025 11:50:04 -0400

openigtlink (1.11.0-5) unstable; urgency=medium

  * Team upload.
  * Reformat d/control with debputy
  * Fix Team name

  [ Jelmer Vernooĳ ]
  * Use correct machine-readable copyright file URI.

  [ Debian Janitor ]
  * Apply multi-arch hints. + openigtlink-doc, openigtlink-examples: Add Multi-Arch: foreign.

 -- Alexandre Detiste <tchet@debian.org>  Mon, 21 Apr 2025 20:01:58 +0200

openigtlink (1.11.0-4) unstable; urgency=medium

  * Team upload.
  * Move packaging from SVN to Git
  * cme fix dpkg-control
  * Remove quilt from Build-Depends (not needed for source/format 3.0 (quilt))
  * Drop manual -dbg package
  * Delete useless autogenerated doxygen files

 -- Andreas Tille <tille@debian.org>  Tue, 23 Jan 2018 16:52:38 +0100

openigtlink (1.11.0-3) unstable; urgency=medium

  * Update debian/watch file
  * Fix lintian error: privacy-breach-logo
  * Fix: Update to Debian Policy 3.9.8 (no changes)

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 23 Apr 2017 18:02:48 -0400

openigtlink (1.11.0-2) unstable; urgency=medium

  * added reproducible_build.patch (Closes: #860278)
  * added gcc7.patch (Closes: 853591)
  * Update to Debian Policy 3.9.8 (no changes)

 -- Dominique Belhachemi <domibel@debian.org>  Fri, 14 Apr 2017 22:30:07 -0400
