=== debian/control ===
Source: openigtlink
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Dominique Belhachemi <domibel@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Build-Depends-Indep:
 doxygen-latex,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/openigtlink
Vcs-Git: https://salsa.debian.org/science-team/openigtlink.git
Homepage: http://openigtlink.org
Rules-Requires-Root: no
X-Style: black

Package: libopenigtlink-dev
Architecture: any
Section: libdevel
Depends:
 libopenigtlink3.0 (= ${binary:Version}),
 ${misc:Depends},
Breaks:
 libopenigtlink1-dev (<< 1.10.4~git20131104+3ac531115f-2),
Replaces:
 libopenigtlink1-dev (<< 1.10.4~git20131104+3ac531115f-2),
Description: Open IGT Link is a simple network protocol - development
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains the development files needed to build
 your own IGT applications.

Package: libopenigtlink3.0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open IGT Link is a simple network protocol - runtime
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains library files for OpenIGTLink.

Package: openigtlink-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Multi-Arch: foreign
Description: Open IGT Link is a simple network protocol - documentation
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains documentation files for OpenIGTLink.

Package: openigtlink-examples
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 libopenigtlink-dev,
Multi-Arch: foreign
Description: Open IGT Link is a simple network protocol - examples
 Open IGT Link is a simple network protocol intended for trackers,
 robots and other devices to send data to the main application.
 Some devices might also accept commands.
 .
 For example applications may include:
  * Stereotactic surgical guidance using optical position sensor and
    medical image visualization software.
  * Intraoperative image guidance using real-time MRI and medical image
    visualization software
  * Robot-assisted intervention using robotic device and surgical planning
    software
 .
 This package contains examples from the OpenIGTLink source.
 .
 Consult /usr/share/doc/libopenigtlink-dev/README.Debian for details.
