=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
#export DH_VERBOSE=1

ABI_VERSION := 3.0

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)

CMAKE_EXTRA_FLAGS = \
        -DCMAKE_SKIP_RPATH:BOOL=ON \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DBUILD_DOCUMENTATION:BOOL=ON \
        -DBUILD_TESTING:BOOL=ON \
        -DBUILD_EXAMPLES:BOOL=OFF \
        -DUSE_GTEST:BOOL=OFF \
	-DOpenIGTLink_PROTOCOL_VERSION_3:BOOL=ON \
	-DOpenIGTLink_INSTALL_LIB_DIR:PATH=lib \
	-DOpenIGTLink_INSTALL_DATA_DIR:PATH=share/openigtlink \
	-DOpenIGTLink_INSTALL_INCLUDE_DIR:PATH=include/openigtlink \
	-DOpenIGTLink_INSTALL_PACKAGE_DIR:PATH=lib/cmake/openigtlink

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	mkdir -p $(BUILDDIR)/Documents/Doxygen
	doxygen -u $(BUILDDIR)/Utilities/Doxygen/doxygen.config
	doxygen $(BUILDDIR)/Utilities/Doxygen/doxygen.config

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --no-parallel -- LD_LIBRARY_PATH="$(CURDIR)/$(BUILDDIR)/bin:$$LD_LIBRARY_PATH"
else
	@echo "Skipping tests due to DEB_BUILD_OPTIONS=nocheck"
endif

override_dh_auto_test-indep:
	@echo "Skipping tests for arch-independent build."

override_dh_auto_install-arch:
	dh_auto_install

override_dh_auto_install-indep:
	@echo "Skipping auto install for arch-independent build."

override_dh_install-arch:
	dh_install -plibopenigtlink${ABI_VERSION}    debian/tmp/usr/lib/*.so.*              usr/lib
	dh_install -plibopenigtlink-dev      debian/tmp/usr/include/openigtlink/*           usr/include/openigtlink
	dh_install -plibopenigtlink-dev      debian/tmp/usr/lib/*.so                        usr/lib
	dh_install -plibopenigtlink-dev      debian/tmp/usr/lib/cmake/openigtlink/*.cmake   usr/lib/cmake/openigtlink

override_dh_install-indep:
	dh_install -popenigtlink-doc $(BUILDDIR)/Documents/Doxygen/html usr/share/doc/openigtlink-doc
	dh_installexamples -popenigtlink-examples Examples/*


get-orig-source:
	/bin/sh $(CURDIR)/debian/get-orig-source
