=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/OpenIGTLink-$1\.tar\.gz/ \
  https://github.com/openigtlink/OpenIGTLink/tags .*/v?(\d\S+)\.tar\.gz
